;-----------------------------------------------------------------------------
; frank the fruit fly
;-----------------------------------------------------------------------------
# pmio.asm is the include file that defines hardware register names 
# the file is included in the tutorial zip file

	; headers, et al.
	.include "pm_init.s"
	pm_header "frank thefly", IRQ_KEY_POWER | IRQ_MUSIC | IRQ_PRC_COPY, 0
	.include "pmrom_music.s"
	.include "pmio.asm"

	.ram	ticker		1
	.ram	ticker2		1
	.ram	ticker3		1
	.ram	wingsflap	1
	.ram	frankdir	1
	.ram 	buttonpress 1
	.ram	buttonpress2	1
	.ram	screennumber 1
	.ram    health 1
	.ram    health10  1
	.ram	sfx_select	1
	.ram	bgm_select	1
	.ram 	bgm_select2	1
	.ram	prc_tick	1
	.ram	screenlock	1
	.ram    collisiontimer 1
	.ram	bites 1
	.ram 	enemytimer 1
	.ram    enemytimersecs 1
	.ram    collisionxplus 1
	.ram    collisionxminus 1
	.ram    collisionyminus 1
	.ram	collisionyplus 1
	.ram 	enemydir 1
	.ram    levelnumber 1
	.ram	nextsnowtimer 1
	.ram    snowtimer 1
	.ram	snowtimersecs 1
	.ram	graytimer 1
	.ram    frankxdir 1
	.ram	frankydir 1
	.ram	pass1 1
	.ram 	pass2 1
	.ram	pass3 1
	.ram	pass4 1
	
	; Power button, shutdown PM
irq_key_power:
	cint CINT_SHUTDOWN

	; Act as VSync counter
irq_prc_copy:

	push hl
	mov hl, prc_tick
	inc [hl]
	pop hl

		mov		l, [levelnumber] 
		cmp		l, 2
		jz		level_2_gray

		mov		l, [screennumber] 
		cmp		l, 11
		jz		level_2_gray


		mov		l, [screennumber] 
		cmp		l, 254
		jz		endthiscrap2


		mov		l, [screennumber] 
		cmp		l, 0
		jz		the_title
	

level_one_gray:
		mov		l, [screennumber] 
		cmp		l, 255
		jz		intro_1_gray
		
		cmp		l, 3
		jz		screen_3
		
		cmp		l, 4
		jz		screen_4_gray
		
		cmp		l, 5
		jz		screen_5_gray
		
		cmp		l, 6
		jz		screen_6
		
		cmp		l, 7
		jz		screen_7_gray
		
		cmp		l, 8
		jz		screen_8
		
		cmp		l, 9
		jz		screen_9_gray
		
		cmp		l, 10
		jz		screen_10		

	
	
screen_1_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t22
    mov		x1, screen1a
	jmp		endthiscrap
_t22:
	mov l,0
	mov [graytimer],l

    mov		x1, screen1b
	jmp		endthiscrap
	
intro_1_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_ti1a
    mov		x1, level1introa
    jmp		endthiscrap
_ti1a:

	mov l,0
	mov [graytimer],l

    mov		x1, level1introb

	jmp		endthiscrap	
	
	
	
level_2_gray:

	mov l,2
	mov [levelnumber],l

		mov		l, [screennumber] 
		cmp		l, 11
		jz		intro_2_gray

		cmp		l, 12
		jz		screen_12_gray
		
		cmp		l, 13
		jz		screen_13_gray
		
		cmp		l, 14
		jz		screen_14_gray
		
		cmp		l, 15
		jz		screen_15_which_one
		
		cmp		l, 16
		jz		screen_16_gray
		
		jmp		screen_igloo

intro_2_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_ti2aa
    mov		x1, level2introa
    jmp		endthiscrap
_ti2aa:
	mov l,0
	mov [graytimer],l

    mov		x1, level2introb

	jmp		endthiscrap



screen_12_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t12aa
    mov		x1, screen12a
    jmp		endthiscrap
_t12aa:
	mov l,0
	mov [graytimer],l

    mov		x1, screen12b

	jmp		endthiscrap

screen_13_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t13aa
    mov		x1, screen13a
    jmp		endthiscrap
_t13aa:
	mov l,0
	mov [graytimer],l

    mov		x1, screen13b

	jmp		endthiscrap
	
screen_14_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t14aa
    mov		x1, screen14a
    jmp		endthiscrap
_t14aa:
	mov l,0
	mov [graytimer],l

    mov		x1, screen14b

	jmp		endthiscrap
	
screen_15_which_one:
		mov		a, [screenlock]	
		cmp		a, 0
		jz		_t15aa
		
    mov		x1, screen15a
    jmp		endthiscrap
	
_t15aa:
    mov		x1, screen15b
	jmp		endthiscrap
	
screen_16_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_ti16aa
    mov		x1, screen16a
    jmp		endthiscrap
_ti16aa:
	mov l,0
	mov [graytimer],l

    mov		x1, screen16b
	jmp		endthiscrap
	
screen_igloo:
    mov		x1, screenigloo
	jmp		endthiscrap	
	
screen_3:
    mov		x1, screen3
	jmp		endthiscrap	
	
screen_4_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t44
    mov		x1, screen4a
	jmp		endthiscrap
_t44:
	mov l,0
	mov [graytimer],l

    mov		x1, screen4b
	jmp		endthiscrap	
	
screen_5_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t5
    mov		x1, screen5a
	jmp		endthiscrap
_t5:
	mov l,0
	mov [graytimer],l

    mov		x1, screen5b
	jmp		endthiscrap	

screen_6:
    mov		x1, screen6
	jmp		endthiscrap	


screen_7_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t7
    mov		x1, screen7a
	jmp		endthiscrap
_t7:
	mov l,0
	mov [graytimer],l

    mov		x1, screen7b
	jmp		endthiscrap	

screen_8:
    mov		x1, screen8
	jmp		endthiscrap	

screen_9_gray:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t9
    mov		x1, screen9a
	jmp		endthiscrap
_t9:
	mov l,0
	mov [graytimer],l

    mov		x1, screen9b
	jmp		endthiscrap	

screen_10:
    mov		x1, screen10
	jmp		endthiscrap	

the_title:
		mov		l, [graytimer]
		inc		l
		mov		[graytimer], l
		
		cmp	l, 1
		jnz		_t2
    mov		x1, title1	
    jmp		endthiscrap
_t2:
	mov l,0
	mov [graytimer],l

    mov		x1, title2
	jmp endthiscrap
	
endthiscrap:
	mov		[REG_BASE+REG_LCD_TILEBGMEM], x1
endthiscrap2:
	rirq IRQ_PRC_COPY



	; .equ		NN				IO_BEGIN		; you can use [NN+...] instead of [nn+...] when required
;-----------------------------------------------------------------------------
; I/O address offsets
;-----------------------------------------------------------------------------
	.equ		BUTTONS			$52

	.equ		BUTTON_POWER	$80
;-----------------------------------------------------------------------------
; Interrupt numbers
;-----------------------------------------------------------------------------
	.equ	IntSuspend		0x21
	.equ	IntShutdown		0x24

;-----------------------------------------------------------------------------
; Title screen Setup
;-----------------------------------------------------------------------------
main:  
	xor a,a
	mov [ticker],a
	mov [ticker2],a
	mov [ticker3],a
	mov [buttonpress],a
	mov [buttonpress2],a
	mov [screenlock],a
	mov [bgm_select],a
	mov [frankdir],a
	mov [screennumber],a
	
	movb [nn+0x40],1
	
	mov a,2
	mov [frankxdir],a	
	
	mov a,0
	mov [frankydir],a		
	
	; Interrupts
	enable_irqs IRQ_KEY_POWER | IRQ_PRC_COPY	

	; Init sound engine and play music (BA = Master time, HL = RAM Ptr)
	mov ba, MAP_BASE
	mov hl, $00FF
	call pmmusic_init

	; Enable interrupt
	enable_mirq
	
	call music1

    movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
	mov		x1, player
    movw	[REG_BASE+REG_LCD_SPRITEMEM], x1
	
    movb	[nn+REG_EVENT2P],INT2P_KEYPAD
    movb	[nn+REG_EVENT2S],INT2S_KEY_POWER

    ; Activate all interrupts
    mov		flags, 0

    movb	[nn+REG_LCD_CNT0], LCD0_RENDER|LCD0_TILEBG|LCD0_MAP12x16|LCD0_SPRITES
    movb	[nn+REG_LCD_CNT1], LCD1_ENABLE|LCD1_REFRESH1

	mov nn,OAM
	mov [nn+0],40
	mov [nn+1],55
	mov [nn+2],0
	mov [nn+3],OAM_ENABLE

	;mov [nn+7],OAM_DISABLE

	mov nn,REG_BASE
	
	jmp title_screen
	
start_game_:
	mov a,5
	mov [frankdir],a

	mov a,2
	mov [frankxdir],a	
	
	mov a,2
	mov [frankydir],a	

	mov a,0
	mov [buttonpress],a	
	mov [screennumber],a	
	
	jmp start_game
	
start_game2_:
	mov a,6
	mov [frankdir],a

	mov a,1
	mov [frankxdir],a	
	
	mov a,2
	mov [frankydir],a	

	mov a,0
	mov [buttonpress],a	
	mov [screennumber],a	
	
	jmp start_game
	
go_to_level_2:
    mov hl, level_2_splash_screen | 0x8000
    mov u, level_2_splash_screen>>15

    jmp hl		
	
;-----------------------------------------------------------------------------
; Move Frank
;-----------------------------------------------------------------------------	
frank_right1:
		mov		a, [nextsnowtimer]
		add		a, 50
		mov		[nextsnowtimer], a

	call frank_right11
	jmp frank_y_movement
	
frank_left1:
		mov		a, [nextsnowtimer]
		add		a, 50
		mov		[nextsnowtimer], a

	call frank_left11
	jmp frank_y_movement
	
frank_up1:
		mov		a, [nextsnowtimer]
		add		a, 50
		mov		[nextsnowtimer], a
	call frank_up
	jmp level_1
	
frank_down1:
		mov		a, [nextsnowtimer]
		add		a, 50
		mov		[nextsnowtimer], a
	call frank_down11
	jmp level_1
	
play_level_2_music:

	mov a,1
	mov [bgm_select],a	
	
	call music1

    mov hl, level_2_splash_screen2 | 0x8000
    mov u, level_2_splash_screen2>>15

    jmp hl	


play_level_2_bgm:
	mov a,3
	mov [bgm_select],a	
	
	call music1
	
    mov hl, level_2_2 | 0x8000
    mov u, level_2_2>>15

    jmp hl		
	
play_sfx_1_level_2:
	
		mov b, 0
		mov a, 0
		shl a
		shl a
		mov hl, sfx_list+2
		add hl, ba
		mov b, [hl]
		dec hl
		dec hl
		mov hl, [hl]	
	
	call pmmusic_playsfx
	
    mov hl, level_2 | 0x8000
    mov u, level_2>>15

    jmp hl	
	
play_sfx_2_level_2:
	
		mov b, 0
		mov a, 1
		shl a
		shl a
		mov hl, sfx_list+2
		add hl, ba
		mov b, [hl]
		dec hl
		dec hl
		mov hl, [hl]	
	
	call pmmusic_playsfx
	
    mov hl, level_2 | 0x8000
    mov u, level_2>>15

    jmp hl		
	
	
stop_level2_intro_music:
	call pmmusic_stopbgm	
	
    mov hl, level_22 | 0x8000
    mov u, level_22>>15

    jmp hl		
	
;-------------------------------
; password screen
;-------------------------------
password_screen_setup:
    movb	b, 95
    movw	HL, TILEMAP+95
	
		mov a,254
		mov [screennumber],a	
	
		mov a,1
		mov [frankxdir],a	
		
		mov a,0
		mov [bites],a
		mov [ticker],a
		mov [buttonpress],a
		mov [buttonpress2],a
		mov [ticker3],a	

bglinearp:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinearp
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
	mov		x1, passwordscreen
	movw	[REG_BASE+REG_LCD_TILEBGMEM], x1

	mov		x1, player
    movw	[REG_BASE+REG_LCD_SPRITEMEM], x1
	
	mov nn,OAM
	mov [nn+0],44
	mov [nn+1],52
	mov [nn+2],0
	mov [nn+3],OAM_ENABLE

	mov nn,REG_BASE		

button_depressed:
	mov a,0
	mov [buttonpress],a	
	mov [buttonpress2],a
	mov [ticker3],a	
	
password_screen_loop:
		call do_i_suspend1
	call password_key_pressed2

	call read_keys1
	test a, KEY_RIGHT
	jnz waiting_for_press_right

	call read_keys1		
	test a, KEY_LEFT
	jnz waiting_for_press_left

	call read_keys1
	test a, KEY_A
	jnz waiting_for_press_a
	
	call read_keys1
	test a, KEY_B
	jnz waiting_for_press_b
	
	call read_keys1
	test a, KEY_C
	jnz waiting_for_press_c

	jmp password_screen_loop
	
password_key_pressed1:
		call do_i_suspend1

		mov		a, [ticker2]
		inc 	a
		mov		[ticker2], a	
		
		mov		a, [ticker2]	
		cmp		a, 3
		jz		password_key_pressed2

		ret	
	
password_key_pressed2:
		mov a,0
		mov [ticker2],a	

		call flap_wings2	
	
		ret

waiting_for_press_a:
		mov a,3
		mov [ticker3],a	

		jmp waiting_for_press

waiting_for_press_b:
		mov a,4
		mov [ticker3],a	

		jmp waiting_for_press

waiting_for_press_c:
		mov a,5
		mov [ticker3],a	

		jmp waiting_for_press

waiting_for_press_left:
		mov a,1
		mov [ticker3],a	

		jmp waiting_for_press

waiting_for_press_right:
		mov a,2
		mov [ticker3],a	

		jmp waiting_for_press	

waiting_for_press:
		call password_key_pressed1

	call read_keys1
	test a, KEY_RIGHT
	jnz button_still_pressed

	call read_keys1	
	test a, KEY_LEFT
	jnz button_still_pressed

	call read_keys1
	test a, KEY_A
	jnz button_still_pressed
	
	call read_keys1
	test a, KEY_B
	jnz button_still_pressed
	
	call read_keys1
	test a, KEY_C
	jnz button_still_pressed

	jmp button_depressed

button_still_pressed:
		mov		a, [buttonpress]
		inc 	a
		mov		[buttonpress], a	
		
		mov		a, [buttonpress]	
		cmp		a, 181
		jz		add_button_press_2		
	
		jmp waiting_for_press
		
add_button_press_2:
		mov a,0
		mov [buttonpress],a	

		mov		a, [buttonpress2]
		inc 	a
		mov		[buttonpress2], a	

		mov		a, [buttonpress2]	
		cmp		a, 1
		jz		get_key_press		
	
		jmp waiting_for_press
	
	
get_key_press:
		call password_key_pressed2
	
		mov a,0
		mov [buttonpress2],a	

		mov		a, [ticker3] 
		cmp		a, 1
		jz		cursor_left
		
		cmp		a, 2
		jz		cursor_right	

		cmp		a, 3
		jz		enter_a_number
		
		cmp		a, 4
		jz		erase_a_number

		jmp	go_to_a_certain_level

cursor_right:
	call password_key_pressed1

	call read_keys1
	test a, KEY_RIGHT
	jnz cursor_right

		mov		a, [OAM+0] 
		cmp		a, 92
		jz		password_screen_loop
		
		mov		a, [OAM+0]
		add		a, 8
		mov		[OAM+0], a	

	jmp button_depressed
				
cursor_left:
	call password_key_pressed1

	call read_keys1
	test a, KEY_LEFT
	jnz cursor_left

		mov		a, [OAM+0] 
		cmp		a, 20
		jz		password_screen_loop
	
		mov		 a, [OAM+0]	
		sub		a, 8
		mov		[OAM+0], a	
		
	jmp button_depressed		
	
erase_a_number:
	call password_key_pressed1
	
	call read_keys1
	test a, KEY_B
	jnz erase_a_number

		mov a,0
		mov [frankxdir],a
		
		mov		a, [bites] 
		cmp		a, 0
		jz		password_screen_loop	
	
		jmp number_erased
	
enter_a_number:
	call password_key_pressed1

	call read_keys1
	test a, KEY_A
	jnz enter_a_number

		mov a,1
		mov [frankxdir],a

		mov		a, [bites] 
		cmp		a, 6
		jz		password_screen_loop

		mov		a, [bites]
		add		a, 1
		mov		[bites], a	

determine_which_number:
		mov		a, [OAM+0] 
		cmp		a, 20
		jz		zero_entered
		
		cmp		a, 28
		jz		one_entered	
		
		cmp		a, 36
		jz		two_entered		
	
		cmp		a, 44
		jz		three_entered		
	
		cmp		a, 52
		jz		four_entered		
	
		cmp		a, 60
		jz		five_entered		
	
		cmp		a, 68
		jz		six_entered		
	
		cmp		a, 76
		jz		seven_entered		
	
		cmp		a, 84
		jz		eight_entered		
	
		cmp		a, 92
		jz		nine_entered		
	
number_erased:
		mov a,95
		mov [frankydir],a	

		jmp number_places	
	
nine_entered:
		mov a,106
		mov [frankydir],a	

		jmp number_places
		
eight_entered:
		mov a,105
		mov [frankydir],a	

		jmp number_places	

seven_entered:
		mov a,104
		mov [frankydir],a	

		jmp number_places	

six_entered:
		mov a,103
		mov [frankydir],a	

		jmp number_places

five_entered:
		mov a,102
		mov [frankydir],a	

		jmp number_places
		
four_entered:
		mov a,101
		mov [frankydir],a	

		jmp number_places		

three_entered:
		mov a,100
		mov [frankydir],a	

		jmp number_places
		
two_entered:
		mov a,99
		mov [frankydir],a	

		jmp number_places		

one_entered:
		mov a,98
		mov [frankydir],a	

		jmp number_places

zero_entered:
		mov a,97
		mov [frankydir],a	

		jmp number_places

number_places:
		mov		a, [bites] 
		cmp		a, 1
		jz		no_1_entered
		
		cmp		a, 2
		jz		no_2_entered
		
		cmp		a, 3
		jz		no_3_entered		
	
		cmp		a, 4
		jz		no_4_entered	
	
		cmp		a, 5
		jz		no_5_entered
	
no_6_entered:
		mov		a, [frankydir]
		mov		[pass4], a	
		
		jmp enter_that_number		
		
no_5_entered:
		mov		a, [frankydir]
		mov		[pass3], a	
		
		jmp enter_that_number	

no_4_entered:
		mov		a, [frankydir]
		mov		[pass2], a	
		
		jmp enter_that_number	

no_3_entered:
		mov		a, [frankydir]
		mov		[health], a	
		
		jmp enter_that_number	
		
no_2_entered:
		mov		a, [frankydir]
		mov		[pass1], a	
		
		jmp enter_that_number	

no_1_entered:
		mov		a, [frankydir]
		mov		[health10], a	
		
		jmp enter_that_number	
	
enter_that_number:
		mov x1, TILEMAP+74
		mov a, [health10]	
		mov [x1], a

		mov x1, TILEMAP+75
		mov a, [pass1]
		mov [x1], a		

		mov x1, TILEMAP+76
		mov a, [health]
		mov [x1], a		

		mov x1, TILEMAP+77
		mov a, [pass2]
		mov [x1], a	

		mov x1, TILEMAP+78
		mov a, [pass3]
		mov [x1], a			

		mov x1, TILEMAP+79
		mov a, [pass4]
		mov [x1], a		

		mov		a, [frankxdir] 
		cmp		a, 0
		jz		subtract_bite

	jmp button_depressed	
	
subtract_bite:
		mov		a, [bites]
		sub		a, 1
		mov		[bites], a
	
	jmp button_depressed
	
go_to_a_certain_level:
	call password_key_pressed1

	mov a,0
	mov [buttonpress],a
	mov [ticker3],a	

	call read_keys1
	test a, KEY_C
	jnz go_to_a_certain_level

continue_go_to_a_certain_level:
		mov		a, [pass1] 
		cmp		a, 104
		jnz		not_level_2_password
		
		mov		a, [pass2] 
		cmp		a, 103
		jnz		not_level_2_password		
		
		mov		a, [pass3] 
		cmp		a, 103
		jnz		not_level_2_password

		mov		a, [pass4] 
		cmp		a, 106
		jnz		not_level_2_password

		mov a,2
		mov [levelnumber],a	

		jmp go_to_level_2
	

not_level_2_password:	
	jmp start_game_now
	
;-----------------------------------------------------------------------------
; Title screen
;-----------------------------------------------------------------------------
title_screen:
		test [nn+REG_KEYPAD],KEY_A
		jz start_game_
		
		test [nn+REG_KEYPAD],KEY_B
		jz start_game2_
		
title_screen_1aaa:
		mov		a, [ticker]
		add		a, 1
		mov		[ticker], a
	
		mov		a, [ticker] 
		cmp		a, 255
		jz		move_frank_ts
	
		jmp title_screen

move_frank_ts:
		call this_blows
		jmp title_screen
		
this_blows:
		mov		a, [ticker2]
		add		a, 1
		mov		[ticker2], a

		mov		a, [ticker2] 
		cmp		a, 4
		jg		move_frank2ts
		
		ret
		
move_frank2ts:
		mov a,0
		mov [ticker2],a	

		call flap_wings

		mov		a, [frankdir] 
		cmp		a, 5
		jz		crap_argh
		
		mov		a, [frankdir] 
		cmp		a, 6
		jz		crap_argh1
	
		mov		a, [frankydir] 
		cmp		a, 0
		jz		move_frank_x_pos
	
		mov		a, [frankydir] 
		cmp		a, 1
		jz		frank_up_ts		
		
		mov		a, [frankydir] 
		cmp		a, 2
		jz		frank_down_ts		
		
move_frank_x_pos:
		mov		a, [frankxdir] 
		cmp		a, 1
		jz		frank_left_ts
		
		mov		a, [frankxdir] 
		cmp		a, 2
		jz		frank_right_ts	
	
crap_argh:
		mov a,2
		mov [frankydir],a		

		mov a,2
		mov [frankxdir],a	
		
		jmp frank_right_ts2

	
frank_right_ts:	
		mov a,2
		mov [frankxdir],a	
		
		mov a,0
		mov [frankydir],a	

frank_right_ts2:
		mov		a, [frankdir] 
		cmp		a, 5
		jnz		crap_argh2

crap_argh2:
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a

		mov		a, [OAM+0] 
		cmp		a, 80
		jz		frank_up_ts

		mov		a, [frankdir] 
		cmp		a, 5
		jz		crap_argh22	
		
		ret
		
start_game_now_f:
			jmp start_game_now
		
crap_argh22:
		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a	
	
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a	
	
		mov		a, [OAM+0] 
		cmp		a, 108
		jg		start_game_now_f
	
		ret
		
frank_up_ts:	
		mov a,1
		mov [frankydir],a	

		mov a,0
		mov [frankxdir],a	

		mov		a, [OAM+1]
		sub		a, 1
		mov		[OAM+1], a		
	
		mov		a, [OAM+1] 
		cmp		a, 27
		jz		frank_left_ts	
	
		ret	
		
frank_left_ts:	
		mov a,0
		mov [frankydir],a	

		mov a,1
		mov [frankxdir],a	

		mov		a, [OAM+0] 
		cmp		a, 30
		jz		frank_down_ts
	
		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a

		ret	
		
frank_down_ts:	
		mov a,2
		mov [frankydir],a	

		mov a,0
		mov [frankxdir],a	


		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a		
	
		mov		a, [OAM+1] 
		cmp		a, 55
		jz		frank_right_ts	
	
		ret		

crap_argh1:
		mov a,2
		mov [frankydir],a		

		mov a,1
		mov [frankxdir],a	
	
		mov		a, [OAM+0] 
		cmp		a, 80
		jz		frank_up_ts


		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a	
	
		mov		a, [OAM+0]
		sub		a, 2
		mov		[OAM+0], a	
	
		mov		a, [OAM+0] 
		cmp		a, 1
		jz		password_screen_setup	
	
		mov		a, [OAM+0] 
		cmp		a, 0
		jz		password_screen_setup
	
		ret	
		
;-----------------------------------------------------------------------------
; Move Frank around.
;-----------------------------------------------------------------------------	
move_frank___:
	call move_frank
		;call flap_wings	
	
	jmp title_screen
		
move_frank:
		mov		a, [ticker2]
		add		a, 1
		mov		[ticker2], a
	
		mov		a, [ticker2] 
		cmp		a, 77
		jl		move_frank2
		
		ret
		
move_frank2:
		mov a,0
		mov [ticker2],a	
		
		mov		a, [ticker3]
		add		a, 1
		mov		[ticker3], a

		mov		a, [ticker3] 
		cmp		a, 252
		jz		move_frank3
		
		ret

move_frank_111:
		mov		a, [ticker]
		add		a, 1
		mov		[ticker], a
	
		mov		a, [ticker] 
		cmp		a, 255
		jl		move_frank___2224234123424124

		ret

move_frank___2224234123424124:
		mov		a, [ticker2]
		add		a, 1
		mov		[ticker2], a
	
		mov		a, [ticker2] 
		cmp		a, 77
		jl		move_frank22
		
		ret
		
move_frank22:
		mov a,0
		mov [ticker2],a	
	
		mov		a, [ticker3]
		add		a, 1
		mov		[ticker3], a

		mov		a, [ticker3] 
		cmp		a, 252
		jz		move_frank_in_game

		ret	
		
move_frank_in_game:
		call flap_wings

		mov a,0
		mov [ticker3],a	

		call read_keys1
		test a, KEY_RIGHT
		jnz frank_right11
		
		call read_keys1
		test a, KEY_LEFT
		jnz frank_left1

frank_y_movement:
		call read_keys1
		test a, KEY_UP
		jnz frank_up1
		
		call read_keys1
		test a, KEY_DOWN
		jnz frank_down1	
		
		ret
	
move_frank3:
		call flap_wings

		mov a,0
		mov [ticker3],a	
	
		mov		a, [frankdir] 
		cmp		a, 5
		jz		frank_right	
	
		mov		a, [OAM+0] 
		cmp		a, 31
		jz		frank_down	
	
		mov		a, [OAM+1] 
		cmp		a, 29
		jz		frank_left
	
		mov		a, [OAM+0] 
		cmp		a, 80
		jz		frank_up

frank_right:
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a
	
		mov		a, [frankdir] 
		cmp		a, 5
		jz		frank_down_start	
	
		ret
	
frank_right11:
		mov		a, [OAM+0] 
		cmp		a, 96
		jg		next_screen_
		
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a
	
		jmp frank_y_movement
	
next_screen_:
		mov		a, [screenlock] 
		cmp		a, 0
		jg		nomove	

		mov		a, [screennumber]
		add		a, 1
		mov		[screennumber], a	

		mov a,24
		mov [OAM+0],a	

		jmp next_screen
	
frank_up:
		mov		a, [OAM+1] 
		cmp		a, 17
		jz		nomove

		mov		a, [OAM+1]
		sub		a, 1
		mov		[OAM+1], a
	
nomove:
		ret
		
frank_left:
		mov		a, [OAM+0] 
		cmp		a, 5
		jz		frank_right	

frank_left11:
		mov		a, [OAM+0] 
		cmp		a, 24
		jz		nomove

		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a
	
		ret
		
frank_down_start:
		mov		a, [wingsflap] 
		cmp		a, 2
		jl		frank_down
		
		ret
		
frank_down:
		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a

		ret
		
frank_down11:
		mov		a, [OAM+1] 
		cmp		a, 72
		jz		nomove

		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a
		ret

start_game_now:
		mov a,24
		mov [OAM+0],a				
	
		mov a,24
		mov [OAM+1],a	
		
		mov a,0
		mov [frankdir],a	
		
		mov a,0
		mov [ticker],a
		
	mov a,106
	mov [health],a

	mov a,106
	mov [health10],a

	call show_health1
	
		jmp read_level
	
read_level:
		mov		a, [levelnumber] 
		cmp		a, 2
		jz		go_to_level_2
	
level_1_splash_screen:

	;jmp go_to_level_2
		

    movb	b, 95
    movw	HL, TILEMAP+95
	
bglinearfffff:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinearfffff

		mov a,1
		mov [levelnumber],a	

		mov a,255
		mov [screennumber],a

	mov		x1, player
    mov	[REG_BASE+REG_LCD_SPRITEMEM], x1

	mov nn,OAM
	mov [nn+0],44
	mov [nn+1],55
	mov [nn+2],0
	mov [nn+3],OAM_DISABLE

	mov nn,REG_BASE

	mov hl, bgm_select
	mov a, 1
	cmp [hl], a
	;jz nomove
	inc [hl]
	mov a, 8
	
	call show_health1
	
	call music1

		mov a,0
		mov [enemytimer],a
		
		mov a,0
		mov [enemytimersecs],a

level_1_intro_music_is_playing:
		call do_i_suspend1

		mov		a, [enemytimer]
		add		a, 1
		mov		[enemytimer], a
		
		mov		a, [enemytimer] 
		cmp		a, 255
		jz		level_1_splash_seconds
	
		jmp level_1_intro_music_is_playing
	
level_1_splash_seconds:
		mov		a, [enemytimersecs]
		add		a, 1
		mov		[enemytimersecs], a
		
		mov		a, [enemytimersecs] 
		cmp		a, 185
		jz		level_1_splash_over

		jmp level_1_intro_music_is_playing
	
level_1_splash_over:  

		call pmmusic_stopbgm

		call read_keys1
		test a, KEY_A
		jnz level_1_splash_over2
		
		jmp level_1_splash_over
		
level_1_splash_over2:		
		call read_keys1
		test a, KEY_A
		jnz level_1_splash_over2		

		mov a,1
		mov [screennumber],a
		mov [levelnumber],a
	
		mov a,0
		mov [enemytimer],a
		
		mov a,0
		mov [enemytimersecs],a	
	
		mov hl, bgm_select
	mov a, 2
	cmp [hl], a
	;jz nomove
	inc [hl]
	mov a, 8	

	call show_health1

	call music1

	mov nn,OAM
	mov [nn+0],33
	mov [nn+1],55
	mov [nn+2],0
	mov [nn+3],OAM_ENABLE
	
	jmp screen1setup

;-----------------------------------------------------------------------------
; Level 1
;-----------------------------------------------------------------------------
level_1:
		call move_frank_111

		call is_health_01

		mov		a, [screennumber] 	
		cmp		a, 2
		jz		screen_2_stuff		
		
		cmp		a, 3
		jz		screen_3_stuff	
		
		cmp		a, 4
		jz		screen_4_stuff		

		cmp		a, 5
		jz		screen_5_stuff	
		
		cmp		a, 6
		jz		screen_6_stuff	
		
		cmp		a, 7
		jz		screen_7_stuff	
		
		cmp		a, 8
		jz		screen_8_stuff			
		
		cmp		a, 9
		jz		screen_9_stuff			
	
		cmp		a, 10
		jz		screen_10_stuff		

		cmp		a, 11
		jz		go_to_level_2		
	
		jmp 	level_1
;-----------------------------------------------------------------------------
; Flap Wings
;-----------------------------------------------------------------------------	
flap_wings2:
		mov		a, [ticker]
		add		a, 1
		mov		[ticker], a

		mov		a, [ticker] 
		cmp		a, 254
		jz		flap_wings3

		ret

flap_wings3:
		mov a,0
		mov [ticker],a
	
flap_wings:
		call do_i_suspend1

		mov		a, [wingsflap]
		add		a, 1
		mov		[wingsflap], a

		mov		a, [wingsflap] 
		cmp		a, 2
		jz		wings_down

		mov		a, [wingsflap] 
		cmp		a, 3
		jz		wings_side

		mov		a, [wingsflap] 
		cmp		a, 4
		jz		wings_down
		
		mov		a, [wingsflap] 
		cmp		a, 5
		jz		reset_wings

		mov a,1
		mov [OAM+2],a
		
		ret
		
		
wings_side:
		mov a,11
		mov [OAM+2],a
		
		ret		
		
wings_down:
		mov		a, [wingsflap] 
		cmp		a, 4
		jg		reset_wings

		mov a,0
		mov [OAM+2],a
		
		ret

reset_wings:
		mov a,1
		mov [wingsflap],a
		
		mov a,1
		mov [OAM+2],a
		
		ret	
		
level_2_splash_screen_ffff:

		mov a,2
		mov [levelnumber],a

			jmp read_level
		
;-----------------------------------------------------------------------------
; Game Starting code/animation
;-----------------------------------------------------------------------------			
start_game:
		jmp title_screen_1aaa

next_screen:
		mov		a, [screennumber] 
		cmp		a, 11
		jz		go_to_level_2		
		
		cmp		a, 10
		jz		screen10setup			
		
		cmp		a, 9
		jz		screen9setup		
		
		cmp		a, 8
		jz		screen8setup		
		
		cmp		a, 7
		jz		screen7setup		
		
		cmp		a, 6
		jz		screen6setup

		cmp		a, 5
		jz		screen5setup
		
		cmp		a, 4
		jz		screen4setup		
		
		cmp		a, 3
		jz		screen3setup	
		
		cmp		a, 2
		jz		screen2setup			
		
		cmp		a, 1
		jz		screen1setup		

		jmp level_1
;-----------------------------------------------------------------------------	
; screen 1 setup
;-----------------------------------------------------------------------------	
screen1setup:   
    movb	b, 95
    movw	HL, TILEMAP+95
	
bglinearffff:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinearffff
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
		call show_health1

		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 2 setup
;-----------------------------------------------------------------------------			
screen2setup:
		mov x1, TILEMAP+23
		mov a, 97	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 97	
		mov [x1], a
		
		mov x1, TILEMAP+47
		mov a, 97	
		mov [x1], a

		mov x1, TILEMAP+59
		mov a, 97	
		mov [x1], a

		mov a,2
		mov [screenlock],a

		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 2 stuff
;-----------------------------------------------------------------------------				
screen_2_stuff:
		mov		a, [OAM+0] 
		cmp		a, 88
		jl		level_11

		call move_frank_111

		call read_keys1
		test a, KEY_A
		jnz test_where_frank_y1
			
		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bp1
		
		mov a,0
		mov [buttonpress],a	

level_11:
		jmp level_1

bp1:
		mov a,2
		mov [buttonpress],a		
		
		jmp bp2

test_where_frank_y1:
		mov		a, [buttonpress] 
		cmp		a, 2
		jz		bp2

		mov a,1
		mov [buttonpress],a

		jmp level_1

bp2:
		mov		a, [screenlock]
		cmp		a, 2
		jz		screen_lock_2
		
		mov		a, [screenlock]
		cmp		a, 3
		jz		screen_lock_3
		
		mov		a, [screenlock]
		cmp		a, 4
		jz		screen_lock_4
		
		; button 4 (48)

		mov		a, [OAM+1] 
		cmp		a, 47
		jl		no_lock

		mov		a, [OAM+1] 
		cmp		a, 52
		jg		no_lock
		
	mov b, 0
	mov a, 1
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx		
		
		mov a,0
		mov [screenlock],a		
		
		jmp level_1
		
screen_lock_2:
		; button 1 (32)

		mov		a, [OAM+1] 
		cmp		a, 31
		jl		no_lock

		mov		a, [OAM+1] 
		cmp		a, 35
		jg		no_lock
		
		jmp unlock_step
		
screen_lock_3:
		; button 2 (40)

		mov		a, [OAM+1] 
		cmp		a, 39
		jl		no_lock

		mov		a, [OAM+1] 
		cmp		a, 43
		jg		no_lock
		
		jmp unlock_step	

screen_lock_4:
		; button 3 (24)

		mov		a, [OAM+1] 
		cmp		a, 23
		jl		no_lock

		mov		a, [OAM+1] 
		cmp		a, 27
		jg		no_lock
		
		jmp unlock_step	
		
no_lock:
	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx

		mov a,2
		mov [screenlock],a

		mov		a, [health]
		sub		a, 2
		mov		[health], a		
	
		mov		a, [health]
		cmp		a, 97
		jl		health_ten

		call show_health1

		jmp level_1
		
health_ten:
		mov		a, [health]
		add		a, 10
		mov		[health], a	

		mov		a, [health10]
		sub		a, 1
		mov		[health10], a		
		
		call show_health1		
		
		jmp level_1
		
unlock_step:
	mov b, 0
	mov a, 1
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx

		mov		a, [screenlock]
		add		a, 1
		mov		[screenlock], a	
		
		jmp level_1

;-----------------------------------------------------------------------------	
; screen 3 setup
;-----------------------------------------------------------------------------	
screen3setup:   
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear3:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear3
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 3 stuff
;-----------------------------------------------------------------------------	
screen_3_stuff:	
		call move_frank_111

		mov		a, [OAM+0] 
		cmp		a, 82
		jg		level_1_	

check_web_1a:	
		mov		a, [OAM+0] 
		cmp		a, 48
		jl		check_web_1b	

screen_3_stuff_2:
		mov		a, [OAM+0] 
		cmp		a, 56
		jg		check_web_2a		
		
level_1_:
		mov a,0
		mov [buttonpress],a	

		jmp level_1	

screen_3_stuff_2a:	
		mov		a, [OAM+1] 
		cmp		a, 22
		jg		check_web_1b

		jmp level_1
		
check_web_1b:
		mov		a, [OAM+1] 
		cmp		a, 28
		jg		check_web_1c	

		jmp level_1

check_web_1c:	
		mov		a, [OAM+1] 
		cmp		a, 52
		jl		lose_health_no_touch

		jmp level_1
		
check_web_2a:
		mov		a, [OAM+1] 
		cmp		a, 40
		jl		lose_health_no_touch	
		
check_web_2b:
		mov		a, [OAM+1] 
		cmp		a, 48
		jg		lose_health_no_touch

		jmp level_1
		
lose_health_no_touch:
		mov		a, [collisiontimer]
		add		a, 1
		mov 	[collisiontimer],a	

		mov		a, [collisiontimer] 
		cmp		a, 254
		jz		lose_health2
		
		jmp level_1

lose_health2:
		mov a,0
		mov [collisiontimer],a	

	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx
	
	jmp lose_health3
	
lose_health:
	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx

		mov		a, [buttonpress]
		add		a, 1
		mov 	[buttonpress],a
			
		mov		a, [buttonpress] 
		cmp		a, 255
		jz		lose_health3
			
		jmp level_1
		
lose_health3:
		mov a,0
		mov [buttonpress],a
	
		mov		a, [health]
		sub		a, 1
		mov		[health], a		
	
		mov		a, [health]
		cmp		a, 97
		jl		health_ten_

		call show_health1

		jmp level_1

health_ten_:
			jmp health_ten

;-----------------------------------------------------------------------------	
; screen 4 setup
;-----------------------------------------------------------------------------			
screen4setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear4:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear4
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	

		jmp level_1

;-----------------------------------------------------------------------------	
; screen 4 stuff
;-----------------------------------------------------------------------------	
screen_4_stuff:
		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bite_that_fruit

		call read_keys1
		test a, KEY_A
		jnz bite_that_fruit
		
		call move_frank_111	
		
		jmp level_1
		
bite_that_fruit:
		call read_keys1
		test a, KEY_A
		jnz stop_biting2

		mov		a, [OAM+0] 
		cmp		a, 45
		jl		stop_biting	

		mov		a, [OAM+0] 
		cmp		a, 88
		jg		stop_biting	

		mov		a, [OAM+1] 
		cmp		a, 50
		jl		stop_biting	
		
		mov		a, [OAM+1] 
		cmp		a, 70
		jg		stop_biting		

		mov		a, [bites]
		add		a, 1
		mov 	[bites],a
			
		mov		a, [bites] 
		cmp		a, 5
		jl		increase_health
		
		jmp stop_biting
		
increase_health:
		mov		a, [health]
		add		a, 2
		mov 	[health],a	
		
		call add_score1
	
stop_biting:
		mov a,0
		mov [buttonpress],a

		jmp level_1
		
stop_biting2:		
		mov a,1
		mov [buttonpress],a
		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 5 setup
;-----------------------------------------------------------------------------			
screen5setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear5:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear5
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		
		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 5 stuff
;-----------------------------------------------------------------------------
dont_go_back_in_argher_:
		jmp dont_go_back_in_argher
			
screen_5_stuff:
		call move_frank_111

		mov		a, [OAM+0] 
		cmp		a, 58
		jg		dont_go_back_in_argher_

		mov		a, [OAM+0] 
		cmp		a, 32
		jl		skip_cat

		mov		a, [OAM+0] 
		cmp		a, 48
		jg		up_cats_head

		mov		a, [OAM+1] 
		cmp		a, 30
		jz		in_cat_mouth
		
		mov		a, [OAM+1] 
		cmp		a, 32
		jz		in_cat_mouth		
	
		mov		a, [OAM+1] 
		cmp		a, 31
		jz		in_cat_mouth	
	
		mov a,32
		mov [OAM+0],a			
		
skip_cat:		
		jmp level_1
		
in_cat_mouth:
		mov		a, [OAM+0] 
		cmp		a, 48
		jg		up_cats_head

		mov a,31
		mov [OAM+1],a		
		
		jmp level_1

hit_throat_back:
		mov		a, [OAM+1] 
		cmp		a, 31
		jl		skip_forcex50

		mov		a, [health]
		sub		a, 3
		mov 	[health],a	

		mov a,254
		mov [buttonpress],a	
		
		mov a,32
		mov [OAM+0],a		

		jmp lose_health			

up_cats_head:
		mov		a, [OAM+0] 
		cmp		a, 59
		jg		skip_cat

		mov a,15
		mov [OAM+2],a

		mov		a, [OAM+0] 
		cmp		a, 52
		jz		hit_throat_back

		mov		a, [OAM+1] 
		cmp		a, 18
		jl		out_of_cats_head
		
		mov		a, [OAM+1] 
		cmp		a, 31
		jz		skip_forcex50_2

forcex50:
		mov a,15
		mov [OAM+2],a

		mov a,51
		mov [OAM+0],a			

skip_forcex50:
		jmp level_1

skip_forcex50_2:
		mov		a, [OAM+0] 
		cmp		a, 52
		jz		hit_throat_back
		
		mov a,15
		mov [OAM+2],a		
		
		jmp level_1

out_of_cats_head:
		mov a,60
		mov [OAM+0],a
		
		jmp level_1

dont_go_back_in_argher:
		mov		a, [OAM+0] 
		cmp		a, 59
		jz		force_60
		
		jmp level_1
		
force_60:
		mov a,60
		mov [OAM+0],a

		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 6 setup
;-----------------------------------------------------------------------------			
screen6setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear6:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear6
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		
	mov nn,OAM
	mov [nn+4],100
	mov [nn+5],25
	mov [nn+6],2
	mov [nn+7],OAM_ENABLE

	mov nn,REG_BASE		
		
		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 6 stuff
;-----------------------------------------------------------------------------
screen_6_stuff:
		call move_frank_111

		mov		a, [wingsflap] 
		cmp		a, 2
		jg		wings_down_bee

		mov a,2
		mov [OAM+6],a

		jmp do_i_move_bee
			
wings_down_bee:
		mov a,3
		mov [OAM+6],a	

do_i_move_bee:
		mov		a, [enemytimer]
		inc 	a
		mov		[enemytimer], a

		mov		a, [enemytimer]
		cmp		a, 255
		jz		new_seconds

		jmp no_collision
		
new_seconds:
		mov a,0
		mov [enemytimer],a	
		
		mov		a, [enemytimersecs]
		inc 	a
		mov		[enemytimersecs], a		
		
		cmp		a, 1
		jg		bee_movement_x
		
		jmp no_collision
		
bee_movement_x:
		mov a,0
		mov [enemytimersecs],a

		mov		a, [OAM+4] 
		cmp		a, [OAM+0]
		jg		bee_left

bee_right:
		mov		a, [OAM+4]
		inc 	a
		mov		[OAM+4], a
		
		jmp bee_movement_y
		
bee_left:
		mov		a, [OAM+4]
		dec 	a
		mov		[OAM+4], a
		
bee_movement_y:
		mov		a, [collisionyminus] 
		cmp		a, [OAM+1]
		jg		bee_up

bee_down:
		mov		a, [OAM+5]
		inc 	a
		mov		[OAM+5], a
		
		jmp bee_collision
		
bee_up:
		mov		a, [OAM+5]
		dec 	a
		mov		[OAM+5], a	

bee_collision:
		mov		a, [OAM+5]
		add 	a, 8
		mov		[collisionyminus], a	

		mov		a, [OAM+5]
		add 	a, 16
		mov		[collisionyplus], a		
		
		mov		a, [OAM+4]
		sub 	a, 4
		mov		[collisionxminus], a	

		mov		a, [OAM+4]
		add 	a, 4
		mov		[collisionxplus], a	

		mov		a, [collisionxplus] 
		cmp		a, [OAM+0]
		jl		no_collision

		mov		a, [collisionxminus] 
		cmp		a, [OAM+0]
		jg		no_collision

		mov		a, [collisionyplus] 
		cmp		a, [OAM+1]
		jl		no_collision

		mov		a, [collisionyminus] 
		cmp		a, [OAM+1]
		jg		no_collision

frank_got_stung:
		mov		a, [health]
		sub		a, 4
		mov 	[health],a	

		mov a,254
		mov [buttonpress],a	
	
		mov		a, [OAM+0]
		cmp		a, 50
		jg		bee_reappear_left
	
		mov a,100
		mov [OAM+4],a		

		jmp lose_health				

bee_reappear_left:
		mov a,36
		mov [OAM+4],a		

		jmp lose_health	

no_collision:	
		jmp level_1
		
;-----------------------------------------------------------------------------	
; screen 7 setup
;-----------------------------------------------------------------------------			
screen7setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear7:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear7
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		mov [bites],a
		
	mov nn,OAM
	mov [nn+7],OAM_DISABLE

	mov nn,REG_BASE		
		
		jmp level_1		

;-----------------------------------------------------------------------------	
; screen 7 stuff
;-----------------------------------------------------------------------------	
screen_7_stuff:
		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bite_that_cherry

		call read_keys1
		test a, KEY_A
		jnz bite_that_cherry
		
		call move_frank_111	
		
		jmp level_1
		
bite_that_cherry:
		call read_keys1
		test a, KEY_A
		jnz stop_biting2_7

		mov		a, [OAM+0] 
		cmp		a, 45
		jl		stop_biting_7	

		mov		a, [OAM+0] 
		cmp		a, 66
		jg		stop_biting_7	

		mov		a, [OAM+1] 
		cmp		a, 56
		jl		stop_biting_7
		
		mov		a, [OAM+1] 
		cmp		a, 70
		jg		stop_biting_7		

		mov		a, [bites]
		add		a, 1
		mov 	[bites],a
			
		mov		a, [bites] 
		cmp		a, 5
		jl		increase_health_7
		
		jmp stop_biting_7
		
increase_health_7:
		mov		a, [health]
		add		a, 2
		mov 	[health],a	
		
		call add_score1
	
stop_biting_7:
		mov a,0
		mov [buttonpress],a

		jmp level_1
		
stop_biting2_7:		
		mov a,1
		mov [buttonpress],a
		jmp level_1

;-----------------------------------------------------------------------------
; screen 8 setup
;-----------------------------------------------------------------------------
screen8setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear8:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear8
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		mov [bites],a
		mov [enemytimer],a
		mov [enemytimersecs],a
		
		mov a,2
		mov [enemydir],a			

	; frog body
	mov nn,OAM
	mov [nn+4],56
	mov [nn+5],45
	mov [nn+6],4
	mov [nn+7],OAM_ENABLE

	; frog tongue
	mov nn,OAM
	mov [nn+8],46
	mov [nn+9],34
	mov [nn+10],6
	mov [nn+11],OAM_ENABLE

	mov nn,REG_BASE			
	
	jmp level_1
	
;-----------------------------------------------------------------------------	
; screen 8 stuff
;-----------------------------------------------------------------------------	
screen_8_stuff:
		call move_frank_111	

		mov		a, [enemytimer]
		add 	a, 1
		mov		[enemytimer], a	

		mov		a, [enemydir]
		cmp 	a, 3
		jz 		frog_sit

		mov		a, [enemytimer]
		cmp 	a, 96
		jz 		frog_facing
		
		jmp end_frog
		
frog_fall___:
		jmp frog_fall
	
frog_jump:
		mov a,0
		mov [enemytimersecs],a

		mov a,2
		mov [enemydir],a

		mov		a, [OAM+5]
		sub 	a, 2
		mov		[OAM+5], a	

		mov		a, [OAM+9]
		sub 	a, 2
		mov		[OAM+9], a		
		
		mov		a, [OAM+5]
		cmp 	a, 25
		jl		frog_fall___

		jmp end_frog
	
frog_sit:
		mov		a, [enemytimer]
		cmp 	a, 94
		jz		add_seconds
		
		jmp frog_is_sitting

add_seconds:
		mov		a, [enemytimersecs]
		add 	a, 1
		mov		[enemytimersecs], a	

		mov		a, [enemytimersecs]
		cmp 	a, 10
		jg 		frog_jump

frog_is_sitting:
		mov a,3
		mov [enemydir],a

		mov		a, [OAM+0]
		cmp 	a, 56
		jg 		frog_sit_right
		
		mov a,8
		mov [OAM+6],a
		mov a,6
		mov [OAM+10],a	
		mov a,46
		mov [OAM+8],a

		jmp end_frog	

frog_sit_right:
		mov a,9
		mov [OAM+6],a
		mov a,7
		mov [OAM+10],a	
		mov a,66
		mov [OAM+8],a

		jmp end_frog

frog_facing:
		mov a,0
		mov [enemytimer],a

		mov		a, [enemydir]
		cmp 	a, 3
		jz 		frog_sit_	

		mov		a, [OAM+0]
		cmp 	a, 56
		jg 		frog_face_right
			
		mov a,4
		mov [OAM+6],a
		mov a,6
		mov [OAM+10],a	
		mov a,46
		mov [OAM+8],a

		jmp move_frog
		
frog_face_right:
		mov a,5
		mov [OAM+6],a
		mov a,7
		mov [OAM+10],a	
		mov a,66
		mov [OAM+8],a

move_frog:
		mov		a, [enemydir]
		cmp 	a, 3
		jz 		frog_sit	

		mov		a, [enemydir]
		cmp 	a, 2
		jz 		frog_jump
		
frog_fall:
		mov a,1
		mov [enemydir],a

		mov		a, [OAM+5]
		add 	a, 2
		mov		[OAM+5], a	

		mov		a, [OAM+9]
		add 	a, 2
		mov		[OAM+9], a		
		
		mov		a, [OAM+5]
		cmp 	a, 65
		jg 		frog_sit____

		jmp end_frog
		
frog_sit____:
		mov a,0
		mov [enemytimer],a

frog_sit_:
		jmp frog_sit

end_frog:
		mov		a, [buttonpress]
		cmp 	a, 254
		jz 		no_collision_frog2
		
frog_collision:	
		call move_frank_111	
		
		mov		a, [OAM+0] 
		cmp		a, 48
		jl		tongue_collision_x

		mov		a, [OAM+0] 
		cmp		a, 64
		jg		tongue_collision_x		
		
		mov		a, [OAM+5]
		add 	a, 0
		mov		[collisionyminus], a			
		
		mov		a, [OAM+5]
		add 	a, 16
		mov		[collisionyplus], a			
		
		mov		a, [collisionyplus] 
		cmp		a, [OAM+1]
		jl		tongue_collision_x

		mov		a, [collisionyminus] 
		cmp		a, [OAM+1]
		jg		tongue_collision_x
		
		jmp collision_happened

tongue_collision_x:
		call move_frank_111	
		
		; you have to check x and y at the same time or else it won't work!
		
		mov		a, [OAM+8]
		sub 	a, 8
		mov		[collisionxminus], a		

		mov		a, [OAM+8]
		add 	a, 8
		mov		[collisionxplus], a			
		
		mov		a, [collisionxplus] 
		cmp		a, [OAM+0]
		jl		no_collision_frog2 

		mov		a, [collisionxminus] 
		cmp		a, [OAM+0]
		jg		no_collision_frog2 

		mov		a, [OAM+9]
		add 	a, 8
		mov		[collisionyplus], a			
		
		mov		a, [collisionyplus] 
		cmp		a, [OAM+1]
		jl		no_collision_frog2
		
		mov		a, [OAM+9] 
		cmp		a, [OAM+1]
		jg		no_collision_frog2
	
		jmp collision_happened	
		
no_collision_frog2:		
		mov a,0
		mov [buttonpress],a

		jmp level_1
		
collision_happened:	
		mov		a, [buttonpress]
		add 	a, 1
		mov		[buttonpress], a	

		mov		a, [buttonpress] 
		cmp		a, 1
		jz		take_away_health
		
		jmp level_1

take_away_health:
	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx
	
		mov		a, [health]
		sub		a, 2
		mov		[health], a		
	
		mov		a, [health]
		cmp		a, 97
		jl		health_tenff

		call show_health1

		jmp level_1

health_tenff:
		mov		a, [health]
		add		a, 10
		mov		[health], a	

		mov		a, [health10]
		sub		a, 1
		mov		[health10], a		
		
		call show_health1	

		jmp level_1
		
;-----------------------------------------------------------------------------
; screen 9 setup
;-----------------------------------------------------------------------------
screen9setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear9:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear9
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		mov [bites],a
		
		mov a,2
		mov [enemydir],a	

	mov nn,OAM
	mov [nn+8],OAM_DISABLE
	
	mov nn,OAM
	mov [nn+4],OAM_DISABLE

	mov nn,REG_BASE		
		
		jmp level_1		

;-----------------------------------------------------------------------------
; screen 9 stuff
;-----------------------------------------------------------------------------
screen_9_stuff:
		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bite_that_strawberry

		call read_keys1
		test a, KEY_A
		jnz bite_that_strawberry
		
		call move_frank_111	
		
		jmp level_1
		
bite_that_strawberry:
		call move_frank_111	

		call read_keys1
		test a, KEY_A
		jnz stop_biting2_9

		mov		a, [OAM+0] 
		cmp		a, 35
		jl		stop_biting_9	

		mov		a, [OAM+0] 
		cmp		a, 72
		jg		stop_biting_9	

		mov		a, [OAM+1] 
		cmp		a, 36
		jl		stop_biting_9
		
		mov		a, [OAM+1] 
		cmp		a, 79
		jg		stop_biting_9	

		mov		a, [bites]
		add		a, 1
		mov 	[bites],a
			
		mov		a, [bites] 
		cmp		a, 5
		jl		increase_health_9
		
		jmp stop_biting_9
		
increase_health_9:
		jmp take_away_health9
		
		call add_score1
	
stop_biting_9:
		mov a,0
		mov [buttonpress],a

		jmp level_1
		
stop_biting2_9:		
		mov a,1
		mov [buttonpress],a
		jmp level_1
		
take_away_health9:
		mov a,0
		mov [buttonpress],a

	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx
	
		mov		a, [health]
		sub		a, 4
		mov		[health], a		
	
		mov		a, [health]
		cmp		a, 97
		jl		health_tenff9

		call show_health1

		jmp level_1

health_tenff9:
		mov		a, [health]
		add		a, 10
		mov		[health], a	

		mov		a, [health10]
		sub		a, 1
		mov		[health10], a		
		
		call show_health1	

		jmp level_1
	
;-----------------------------------------------------------------------------
; screen 10 setup
;-----------------------------------------------------------------------------
screen10setup: 
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear10:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear10
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health1

		mov a,0
		mov [buttonpress],a	
		mov [bites],a
		
		mov a,2					; put this back to 2
		mov [screenlock],a	

		mov nn,REG_BASE		
		
		jmp level_1	
	
;----------------
; screen 10 stuff
;----------------	
screen_10_stuff:
		mov		a, [OAM+1] 
		cmp		a, 25
		jl		free_movement	
	
		; tree 1
	
		mov		a, [OAM+0] 
		cmp		a, 35
		jz		avoid_movement_minus
	
		mov		a, [OAM+0] 
		cmp		a, 42
		jz		avoid_movement_plus	
	
		mov		a, [OAM+0] 
		cmp		a, 35
		jg		avoid_movement_y1
		
		jmp tree2
		
avoid_movement_y1:
		mov		a, [OAM+0] 
		cmp		a, 42
		jl		avoid_movement_y
		
tree2:
		mov		a, [OAM+0] 
		cmp		a, 71
		jz		avoid_movement_minus
	
		mov		a, [OAM+0] 
		cmp		a, 78
		jz		avoid_movement_plus	

		mov		a, [OAM+0] 
		cmp		a, 71
		jg		tree2y
		
		call move_frank_111		
		jmp free_movement
		
tree2y:
		mov		a, [OAM+0] 
		cmp		a, 77
		jl		avoid_movement_y
		
		call move_frank_111		

free_movement:
		mov		a, [OAM+0] 
		cmp		a, 42
		jg		do_i_unlock_screen10

		mov		a, [OAM+0] 
		cmp		a, 71
		jl		do_i_unlock_screen10	
	
		jmp avoid_movement
		
avoid_movement_plus:
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a				
		
		jmp avoid_movement
	
avoid_movement_minus:
		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a				
		
		jmp avoid_movement
		
avoid_movement_y:
		mov		a, [OAM+1]
		sub		a, 1
		mov		[OAM+1], a				
		
		jmp avoid_movement
	
avoid_movement_ggg:
		mov a,43
		mov [OAM+0],a			
		
		jmp avoid_movement
		
do_i_unlock_screen10:
		mov		a, [OAM+1] 
		cmp		a, 70
		jg		unlock_screen_10
	
		jmp avoid_movement

unlock_screen_10:
		mov a,0
		mov [screenlock],a	
	
		mov a,69
		mov [OAM+1],a		
	
	mov b, 0
	mov a, 1
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx

avoid_movement:
		call move_frank_111	
	
		jmp level_1
	
	
	
;-----------------------------------------------------------------------------	
; health meter
;-----------------------------------------------------------------------------	
show_health1:
		mov x1, TILEMAP+72
		mov a, [health10]	
		mov [x1], a

		mov x1, TILEMAP+84
		mov a, [health]
		mov [x1], a	

		ret

;-----------------------------------------------------------------------------
; add to health
;-----------------------------------------------------------------------------
add_score1:	
	mov b, 0
	mov a, 1
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playsfx
	
		mov		a, [health] 
		cmp		a, 106
		jg		add_tens1
	
		call show_health1
	
		ret
		
add_tens1:
		mov		a, [health]
		sub		a, 10
		mov		[health], a

		mov		a, [health10]
		inc 	a
		mov		[health10], a
		
		mov		a, [health10] 
		cmp		a, 106
		jg		health_is_991		
		
		call show_health1	
		
		ret
		
health_is_991:
		mov a,106
		mov [health],a	
		mov [health10],a

		call show_health1
	
		ret

	
;-----------------------------------------------------------------------------	
; music
;-----------------------------------------------------------------------------	
music1:
	mov b, 0
	mov a, [bgm_select]
	shl a
	shl a
	mov hl, bgm_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	call pmmusic_playbgm
	
	ret

;-----------------------------------------------------------------------------
; Read Keypad Return A, 0 = Released, 1 = Pressed
;-----------------------------------------------------------------------------
read_keys1:
	mov a, [n+KEY_PAD]
	push b
	mov b, [n+KEY_PAD]
	xor a, b
	mov a, b
	pop b
	jnz read_keys1
	not a
	ret		
	
;-----------------------------------------------------------------------------
; suspend or not
;-----------------------------------------------------------------------------
do_i_suspend1:
	test	[nn+BUTTONS], BUTTON_POWER
	jnz		_dont_suspend21
	int		IntSuspend
_dont_suspend21:
	ret

;---------------------------
; check for health being 0
;---------------------------
is_health_01:
	mov		a, [health10]
	cmp 	a, 96
	jnz		go_back_to_game1
	
	mov a,0
	mov [screennumber],a
		
	jmp main
	
go_back_to_game1:
	ret

	pm_align_tiles
	
screen12a:
	.incbin frankscreen12a.bin
screen12b:
	.incbin frankscreen12b.bin	
screen13a:
	.incbin frankscreen13a.bin
screen13b:
	.incbin frankscreen13b.bin	
screen14a:
	.incbin frankscreen14a.bin
screen14b:
	.incbin frankscreen14b.bin	
screen15a:
	.incbin frankscreen15one.bin
screen15b:
	.incbin frankscreen15two.bin	
screen16a:
	.incbin frankscreen16a.bin
screen16b:
	.incbin frankscreen16b.bin	
screenigloo:
	.incbin frankigloo.bin
level2introa:
	.incbin franklevel2introa.bin
level2introb:
	.incbin franklevel2introb.bin
	
title1:
	.incbin franktitle5a.bin	
title2:
	.incbin franktitle5b.bin		

passwordscreen:
	.incbin passwordentry.bin
	
level1introa:
	.incbin franklevel1introa.bin
level1introb:
	.incbin franklevel1introb.bin	

screen1a:
	.incbin frankscreen1aa.bin	
screen1b:
	.incbin frankscreen1ab.bin	
screen3:
	.incbin frankscreen3.bin	
screen4a:
	.incbin frankscreen4a.bin	
screen4b:
	.incbin frankscreen4b.bin	
screen5a:
	.incbin frankscreen5a.bin	
screen5b:
	.incbin frankscreen5b.bin		
screen6:
	.incbin frankscreen6.bin	
screen7a:
	.incbin frankscreen7a.bin
screen7b:
	.incbin frankscreen7b.bin	
screen8:
	.incbin frankscreen8.bin
screen9a:
	.incbin frankscreen9a.bin
screen9b:
	.incbin frankscreen9b.bin	
screen10:
	.incbin frankscreen10.bin
	
	
	pm_align_spr	
player:
	.incbin franksprites8.bin	
player2:
	.incbin frankspriteslevel2c.bin		
	
	
	
	.align 16	
	
sfx_list:
	.dd sound_fx0
	.dd sound_fx1
	
sfx_list_last:	.db 2	
bgm_list_last:	.db 4	

bgm_list:
	.dd music_test2
	.dd music_level_intro	
	.dd level_1_music
	.dd level_2_music

	PMMUSIC_ALIGN

sound_fx0:
	PMMUSIC_ROW N_C_5, $80, 3, 1
	PMMUSIC_ROW N_B_4, $80, 3, 1
	PMMUSIC_ROW N_A_4, $80, 3, 1
	PMMUSIC_END

sound_fx1:
	PMMUSIC_ROW N_C_5, $80, 3, 1
	PMMUSIC_ROW N_E_5, $80, 3, 1
	PMMUSIC_ROW N_G_5, $80, 3, 1
	PMMUSIC_ROW N_C_6, $80, 3, 1
	PMMUSIC_END

	.include "music_title2a.asm"		
	.include "music_title4.asm"
	.include "level_1_musiclong.asm"			
	.include "level_2_musiclong.asm"

	.orgfill 0x10000	
		



level_2_splash_screen: 

    mov hl, play_level_2_music|0x8000
    mov u, play_level_2_music>>15
    jmp hl

level_2_splash_screen2:

	mov a,11
	mov [screennumber],a	
	
	mov a,2
	mov [levelnumber],a		
	
	movb	b, 95
    movw	HL, TILEMAP+95
	
bglinear3ddddf:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear3ddddf

    movw	sp,REG_BASE
    movw	nn,REG_BASE	

	call show_health
	
	mov		x1, level2introa
	movw	[REG_BASE+REG_LCD_TILEBGMEM], x1

	mov		x1, player2
    movw	[REG_BASE+REG_LCD_SPRITEMEM], x1

	mov nn,OAM
	mov [nn+0],44
	mov [nn+1],55
	mov [nn+2],0
	mov [nn+3],OAM_DISABLE

	mov nn,REG_BASE

	mov hl, bgm_select2
	mov a, 1
	cmp [hl], a
	;jz nomove
	inc [hl]
	mov a, 8
	
	

	mov a,104
	mov [pass1],a	

	mov a,103
	mov [pass2],a
	
	mov a,103
	mov [pass3],a	

	mov a,106
	mov [pass4],a

		mov x1, TILEMAP+74
		mov a, [health10]	
		mov [x1], a

		mov x1, TILEMAP+75
		mov a, [pass1]
		mov [x1], a		

		mov x1, TILEMAP+76
		mov a, [health]
		mov [x1], a		

		mov x1, TILEMAP+77
		mov a, [pass2]
		mov [x1], a	

		mov x1, TILEMAP+78
		mov a, [pass3]
		mov [x1], a			

		mov x1, TILEMAP+79
		mov a, [pass4]
		mov [x1], a		
		
		mov a,2
		mov [levelnumber],a

		mov a,0
		mov [enemytimer],a
		
		mov a,0
		mov [enemytimersecs],a

level_2_intro_music_is_playing:
		call do_i_suspend

		mov		a, [enemytimer]
		add		a, 1
		mov		[enemytimer], a
		
		mov		a, [enemytimer] 
		cmp		a, 255
		jz		level_2_splash_seconds
	
		jmp level_2_intro_music_is_playing
	
level_2_splash_seconds:
		mov		a, [enemytimersecs]
		add		a, 1
		mov		[enemytimersecs], a
		
		mov		a, [enemytimersecs] 
		cmp		a, 185
		jz		level_2_splash_over

		jmp level_2_intro_music_is_playing
	
level_2_splash_over:  

		mov hl, stop_level2_intro_music|0x8000
		mov u, stop_level2_intro_music>>15
		jmp hl		
		
level_22:		
		call read_keys
		test a, KEY_A
		jnz level_2_splash_over2
		
		jmp level_22
		
level_2_splash_over2:		
		call read_keys
		test a, KEY_A
		jnz level_2_splash_over2

		mov a,12
		mov [screennumber],a	
	
		mov a,2
		mov [levelnumber],a	
	
		mov a,0
		mov [enemytimer],a
		
		mov a,0
		mov [enemytimersecs],a	
			
		mov hl, play_level_2_bgm|0x8000
		mov u, play_level_2_bgm>>15
		jmp hl		
		
level_2_2:
	call show_health

	call get_new_snow

	mov nn,OAM
	mov [nn+0],33
	mov [nn+1],55
	mov [nn+2],0
	mov [nn+3],OAM_ENABLE

		;mov a,5
		;mov [frankdir],a

		;jmp screen14setup

level_2_stuff:
		call get_new_snow

		mov		a, [screennumber] 
		cmp		a, 12
		jz		screen12setup	

		cmp		a, 13
		jz		screen13setup	

		cmp		a, 14
		jz		screen14setup	

		cmp		a, 15
		jz		screen15setup	
		
		cmp		a, 16
		jz		screen16setup	

		jmp		igloosetup			


level_2:
		;call irq_prc_copy2


		mov		a, [screennumber] 
		cmp		a, 13
		jz		screen_13_stuff
		
		cmp		a, 14
		jz		screen_14_stuff		
		
		cmp		a, 15
		jz		screen_15_stuff		

		cmp		a, 16
		jz		screen_16_stuff	
	
		cmp		a, 200
		jz		igloo_stuff	


		jmp	screen_12_stuff		
	
;-----------------------------------------------------------------------------
; screen 11 setup
;-----------------------------------------------------------------------------
screen12setup: 
	mov a,12
	mov [screennumber],a

	movb	b, 95
    movw	HL, TILEMAP+95
bglinear12:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear12
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

	call get_new_snow

	mov nn,OAM	
	mov	[nn+4],ticker
	mov [nn+5],1
	mov [nn+6],2
	mov [nn+7],OAM_ENABLE	
	
		mov		a, [OAM+4]
		add		a, 47
		mov		[OAM+4], a		
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health

		mov a,0
		mov [buttonpress],a	
		mov [bites],a

		mov nn,REG_BASE		
		
		jmp level_2	

;----------------
; screen 12 stuff
;----------------
screen_12_stuff:
		call move_frank_222	

		call snow_falling
		
		call move_frank_222	
		
		jmp level_2
	
;-----------------------------------------------------------------------------
; screen 13 setup
;-----------------------------------------------------------------------------
screen13setup: 
		mov a,13
		mov [screennumber],a
		
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear13:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear13
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

	call get_new_snow

	mov nn,OAM
	mov [nn+4],ticker
	mov [nn+5],1
	mov [nn+6],2
	mov [nn+7],OAM_ENABLE	
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health

		mov a,0
		mov [buttonpress],a	
		mov [bites],a

		mov nn,REG_BASE		
		
		jmp level_2			

;----------------
; screen 13 stuff
;----------------
screen_13_stuff:
		call snow_falling
		
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 40
		jl      brick_wall_2
		
		mov		a, [OAM+0] 
		cmp		a, 50
		jl		pushback1
		
		mov		a, [OAM+0] 
		cmp		a, 50
		jz		pushforwards1

brick_wall_2:
		; brick wall #2
		mov		a, [OAM+0] 
		cmp		a, 56
		jl      brick_wall_3
		
		mov		a, [OAM+0] 
		cmp		a, 66
		jl		pushback2

		mov		a, [OAM+0] 
		cmp		a, 66
		jz		pushforwards2

brick_wall_3:
		; brick wall #3
		mov		a, [OAM+0] 
		cmp		a, 72
		jl      brick_wall_4
		
		mov		a, [OAM+0] 
		cmp		a, 82
		jl		pushback1
		
		mov		a, [OAM+0] 
		cmp		a, 82
		jz		pushforwards1		

brick_wall_4:
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 88
		jl      exit_this_madness
		
		mov		a, [OAM+0] 
		cmp		a, 98
		jl		pushback2
		
		mov		a, [OAM+0] 
		cmp		a, 98
		jz		pushforwards2	

exit_this_madness:
		call move_frank_222			
		
		jmp screen_13_move		
		
pushback1:
		mov		a, [OAM+1] 
		cmp		a, 20
		jz		push_y_back_1
		
		jmp push_x_back_1
		
pushforwards1:
		mov		a, [OAM+1] 
		cmp		a, 20
		jz		push_y_back_1
		
		jmp push_x_forwards_1	
		
pushback2:
		mov		a, [OAM+1] 
		cmp		a, 65
		jz		push_y_forwards_2
		
		jmp push_x_back_2
		
pushforwards2:
		mov		a, [OAM+1] 
		cmp		a, 65
		jz		push_y_forwards_2
		
		jmp push_x_forwards_2

screen_13_move:		
		call move_frank_222
	
		jmp level_2
		
move_craphead1:
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 40
		jg		screen_13_move
	
		mov		a, [OAM+0] 
		cmp		a, 48
		jl		screen_13_move
			
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 72
		jg		screen_13_move
	
		mov		a, [OAM+0] 
		cmp		a, 80
		jl		screen_13_move		
		

		mov		a, [OAM+1] 
		cmp		a, 25
		jz		push_y_back_1	
		
		jmp level_2
		
move_craphead2:
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 56
		jg		screen_13_move
	
		mov		a, [OAM+0] 
		cmp		a, 64
		jl		screen_13_move
		
		; brick wall #1
		mov		a, [OAM+0] 
		cmp		a, 88
		jg		screen_13_move
	
		mov		a, [OAM+0] 
		cmp		a, 96
		jl		screen_13_move	

		mov		a, [OAM+1] 
		cmp		a, 65
		jz		push_y_forwards_2

		jmp level_2
	
push_y_back_1:
		mov		a, [OAM+1]
		sub		a, 2
		mov		[OAM+1], a		
		jmp level_2	

push_x_back_1:
		mov		a, [OAM+1] 
		cmp		a, 20
		jl		screen_13_move_

		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a		
		jmp level_2

push_y_forwards_1:	
		mov		a, [OAM+1]
		add		a, 2
		mov		[OAM+1], a				
		jmp level_2

push_x_forwards_1:
		mov		a, [OAM+1] 
		cmp		a, 20
		jl		screen_13_move_

		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a		
		jmp level_2
	
push_y_back_2:
		mov		a, [OAM+1]
		sub		a, 1
		mov		[OAM+1], a		
		jmp level_2	

push_x_back_2:
		mov		a, [OAM+1] 
		cmp		a, 65
		jg		screen_13_move_

		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a		
		jmp level_2

push_y_forwards_2:	
		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a				
		jmp level_2

push_x_forwards_2:
		mov		a, [OAM+1] 
		cmp		a, 65
		jg		screen_13_move_

		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a		
		jmp level_2

screen_13_move_:		
		call move_frank_222	
		call move_frank_222
		jmp level_2

;-----------------------------------------------------------------------------
; screen 14 setup
;-----------------------------------------------------------------------------
screen14setup: 
		mov a,14
		mov [screennumber],a
		
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear14:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear14
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

	call get_new_snow

		mov a,30
		mov [OAM+0],a


	mov nn,OAM
	mov [nn+4],ticker
	mov [nn+5],1
	mov [nn+6],2
	mov [nn+7],OAM_ENABLE	
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health

		mov a,0
		mov [buttonpress],a	
		mov [bites],a

		mov nn,REG_BASE		
		
		jmp level_2			

;----------------
; screen 14 stuff
;----------------
screen_14_stuff:
		call move_frank_222	

		call snow_falling

		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bite_that_pear

		call read_keys
		test a, KEY_A
		jnz bite_that_pear
		
		call move_frank_222	
		
		jmp level_2
		
bite_that_pear:
		call read_keys
		test a, KEY_A
		jnz stop_biting2_14

		mov		a, [OAM+0] 
		cmp		a, 45
		jl		stop_biting_14	

		mov		a, [OAM+0] 
		cmp		a, 66
		jg		stop_biting_14	

		mov		a, [OAM+1] 
		cmp		a, 47
		jl		stop_biting_14
		
		mov		a, [OAM+1] 
		cmp		a, 70
		jg		stop_biting_14		

		mov		a, [bites]
		add		a, 1
		mov 	[bites],a
			
		mov		a, [bites] 
		cmp		a, 5
		jl		increase_health_14
		
		jmp stop_biting_14
		
increase_health_14:
		mov		a, [health]
		add		a, 2
		mov 	[health],a	
		
		call add_score
	
stop_biting_14:
		mov a,0
		mov [buttonpress],a

		jmp level_2
		
stop_biting2_14:		
		mov a,1
		mov [buttonpress],a
		jmp level_2



;-----------------------------------------------------------------------------
; screen 15 setup
;-----------------------------------------------------------------------------
screen15setup: 
		mov a,15
		mov [screennumber],a
		
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear15:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear15
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

	;call get_new_snow

	mov nn,OAM
	mov [nn+4],ticker
	mov [nn+5],1
	mov [nn+6],2
	mov [nn+7],OAM_DISABLE	
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health

		mov a,1
		mov [screenlock],a
		
		mov a,0
		mov [buttonpress],a	

		mov nn,REG_BASE		
		
		jmp level_2			

;-----------------------------------------------------------------------------
; screen 15 stuff
;-----------------------------------------------------------------------------
screen_15_stuff:	
		call move_frank_222	
		
		mov		a, [screenlock] 
		cmp		a, 0
		jz		dont_impede_screen_15
		
		mov		a, [OAM+0] 
		cmp		a, 57
		jz		screen_15_impeding
		
		jmp dont_impede_screen_15
		
screen_15_impeding:
		mov a,56
		mov [OAM+0],a
		
dont_impede_screen_15:
		call move_frank_222	

		mov		a, [buttonpress] 
		cmp		a, 1
		jz		bite_that_eye		

		call read_keys
		test a, KEY_A
		jnz bite_that_eye

		jmp level_2
		
bite_that_eye:
		call read_keys
		test a, KEY_A
		jnz whywontthiscrapwork
		
		jmp you_15
		
whywontthiscrapwork:
		mov		a, [OAM+0] 
		cmp		a, 48
		jl		you_15

		mov		a, [OAM+0] 
		cmp		a, 54
		jg		you_15
		
		mov		a, [OAM+1] 
		cmp		a, 20
		jg		you_15

		mov a,0
		mov [screenlock],a
		mov [buttonpress],a
		
		mov b, 0
		mov a, 1
		shl a
		shl a
		mov hl, sfx_list+2
		add hl, ba
		mov b, [hl]
		dec hl
		dec hl
		mov hl, [hl]
		
		mov hl, play_sfx_2_level_2|0x8000
		mov u, play_sfx_2_level_2>>15
		jmp hl		
 
		
you_15:
		jmp level_2
		
stop_biting2_15:		
		mov a,1
		mov [buttonpress],a
		
		jmp level_2		
		

;-----------------------------------------------------------------------------
; screen 16 setup
;-----------------------------------------------------------------------------
screen16setup: 
		mov a,1
		mov [screenlock],a

screen16setup2:
		mov a,16
		mov [screennumber],a
		
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear16:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear16
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

	call get_new_snow

	mov nn,OAM
	mov [nn+4],ticker
	mov [nn+5],1
	mov [nn+6],2
	mov [nn+7],OAM_ENABLE	
	
		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health
		
		mov a,0
		mov [buttonpress],a	

		mov nn,REG_BASE		
		
		jmp level_2					
		
;-----------------------------------------------------------------------------
; screen 16 stuff
;-----------------------------------------------------------------------------
screen_16_stuff:	



		call snow_falling

dont_fall_snow:
		call move_frank_222	
		
		mov		a, [screenlock] 
		cmp		a, 0
		jz		dont_impede_screen_16
		
		mov		a, [OAM+0] 
		cmp		a, 86
		jz		screen_16_impeding
		
		jmp does_frank_enter_igloo
		
screen_16_impeding:
		mov a,85
		mov [OAM+0],a
		
		jmp does_frank_enter_igloo
		
dont_impede_screen_16:
		mov a,0
		mov [graytimer],a

does_frank_enter_igloo:
		mov		a, [OAM+0] 
		cmp		a, 48
		jl		no_entering_igloo
		
		mov		a, [OAM+0] 
		cmp		a, 56
		jg		no_entering_igloo		
		
		mov		a, [OAM+1] 
		cmp		a, 59
		jl		no_entering_igloo
		
		mov		a, [OAM+1] 
		cmp		a, 66
		jg		no_entering_igloo		
		
		call read_keys
		test a, KEY_A
		jnz igloosetup

no_entering_igloo:	
			call move_frank_222	
		jmp level_2		
		
;-----------------------------------------------------------------------------
; igloo setup
;-----------------------------------------------------------------------------
igloosetup: 
		mov a,200
		mov [screennumber],a
		
	movb	b, 95
    movw	HL, TILEMAP+95
bglinear200:
    movb	[HL], b   ### write the counter variable to the map
    dec		HL        ### decrease map address
    jdbnz       bglinear200
	
    movw	sp,REG_BASE
    movw	nn,REG_BASE		

		mov a,40
		mov [OAM+0],a

		mov x1, TILEMAP+23
		mov a, 2	
		mov [x1], a
		
		mov x1, TILEMAP+35
		mov a, 2	
		mov [x1], a
		
		call show_health

		mov a,0
		mov [buttonpress],a	

		mov nn,OAM
		mov [nn+7],OAM_DISABLE	

		mov nn,REG_BASE		
		
		jmp level_2	
		
;-----------------------------------------------------------------------------
; igloo stuff
;-----------------------------------------------------------------------------
igloo_stuff:	
		call move_frank_222	


		mov		a, [OAM+0] 
		cmp		a, 37
		jl		exit_igloo

		mov		a, [OAM+0] 
		cmp		a, 90
		jz		dont_exit_igloo
		
		jmp igloo_switch_check

dont_exit_igloo:		
		mov a,89
		mov [OAM+0],a

		jmp igloo_eee

igloo_switch_check:
		mov		a, [OAM+0] 
		cmp		a, 72
		jl		igloo_eee
		
		mov		a, [OAM+0] 
		cmp		a, 80
		jg		igloo_eee	

		mov		a, [OAM+1] 
		cmp		a, 56
		jl		igloo_eee
		
		mov		a, [OAM+1] 
		cmp		a, 64
		jg		igloo_eee

		call read_keys
		test a, KEY_A
		jnz wall_disappear
	
igloo_eee:


igloo_fff:
		jmp level_2
	
wall_disappear:
		mov a,0
		mov [screenlock],a

		mov		a, [buttonpress] 
		cmp		a, 5
		jz		ereeee

		mov		a, [buttonpress]
		inc 	a
		mov		[buttonpress], a


		mov		a, [buttonpress] 
		cmp		a, 1
		jz		sssssfffffxxxx

		jmp level_2

ereeee:	
		mov a,5
		mov [buttonpress],a

		jmp level_2

sssssfffffxxxx:
		mov hl, play_sfx_2_level_2|0x8000
		mov u, play_sfx_2_level_2>>15
		jmp hl		

exit_igloo:
		mov		a, [OAM+1] 
		cmp		a, 44
		jg		really_exit_igloo

		jmp level_2
		
		
really_exit_igloo:
		mov a,48
		mov [OAM+0],a
		
		mov a,66
		mov [OAM+1],a		

		jmp screen16setup2
		
;--------------
; snow_screens
;--------------	
snow_falling:

		mov		a, [screennumber] 
		cmp		a, 15
		jz		forget_snow

		mov		a, [screennumber] 
		cmp		a, 200
		jz		forget_snow

		mov		a, [OAM+5]
		sub 	a, 8
		mov		[collisionyminus], a	

		mov		a, [OAM+5]
		add 	a, 12
		mov		[collisionyplus], a		
		
		mov		a, [OAM+4]
		sub 	a, 8
		mov		[collisionxminus], a	

		mov		a, [OAM+4]
		add 	a, 8
		mov		[collisionxplus], a	

		mov		a, [collisionxplus] 
		cmp		a, [OAM+0]
		jl		no_snow_collision

		mov		a, [collisionxminus] 
		cmp		a, [OAM+0]
		jg		no_snow_collision

		mov		a, [collisionyplus] 
		cmp		a, [OAM+1]
		jl		no_snow_collision

		mov		a, [collisionyminus] 
		cmp		a, [OAM+1]
		jg		no_snow_collision

snow_collision:
		mov		a, [health]
		sub		a, 4
		mov 	[health],a	

		mov a,254
		mov [buttonpress],a			

		call get_new_snow
		
		jmp lose_health_level_2

no_snow_collision:
		mov		a, [snowtimer]
		inc 	a
		mov		[snowtimer], a
		
		mov		a, [nextsnowtimer]
		inc 	a
		mov		[nextsnowtimer], a		
		
		mov		a, [snowtimer] 
		cmp		a, 0
		jz		snow_timer_secs

forget_snow:
		ret

snow_timer_secs:
		mov		a, [snowtimersecs]
		inc 	a
		mov		[snowtimersecs], a
		
		mov		a, [snowtimersecs] 
		cmp		a, 3
		jz		fall_that_snow_now
		
		ret

fall_that_snow_now:
		mov a,0
		mov [snowtimersecs],a	

		mov		a, [OAM+5]
		inc 	a
		inc		a
		mov		[OAM+5], a
		
		mov		a, [OAM+5] 
		cmp		a, 81
		jz		get_new_snow

		ret

get_new_snow:
		mov a,1
		mov [OAM+5],a

; Get the lower byte from the timer.
  mov	a, [0x2041]
  and   a, 0b001101100

	mov [OAM+4],a

		mov		a,[OAM+4]
		add		a, 47
		mov 	[OAM+4],a	
	
		mov		a, [OAM+4] 
		cmp		a, 24
		jl		snow_extreme_left		
	
		mov		a, [OAM+4] 
		cmp		a, 100
		jg		snow_extreme_right		
		
		mov [ticker],a
		
		ret
		
snow_extreme_left:
		mov		a, 24
		mov 	[OAM+4],a	
		mov [ticker],a			
		ret
		
snow_extreme_right:
		mov		a, 100
		mov 	[OAM+4],a	
		mov [ticker],a
		ret		
		
;-----------------------------------------------------------------------------	
; health meter
;-----------------------------------------------------------------------------	
show_health:
		mov x1, TILEMAP+72
		mov a, [health10]	
		mov [x1], a

		mov x1, TILEMAP+84
		mov a, [health]
		mov [x1], a	

		ret

;-----------------------------------------------------------------------------
; add to health
;-----------------------------------------------------------------------------
add_score:	

		mov		a, [health] 
		cmp		a, 106
		jg		add_tens
	
		jmp show_health2
	
		
add_tens:
		mov		a, [health]
		sub		a, 10
		mov		[health], a

		mov		a, [health10]
		inc 	a
		mov		[health10], a
		
		mov		a, [health10] 
		cmp		a, 106
		jg		health_is_99		
		
		jmp show_health2	
		
	
		
health_is_99:
		mov a,106
		mov [health],a	
		mov [health10],a

		jmp show_health2
	
	
		
;--------------
; delete health for level 2
;--------------
lose_health___:
	jmp lose_health_level_2
	
;-----------------------------------------------------------------------------	
; music
;-----------------------------------------------------------------------------	


;-----------------------------------------------------------------------------
; Read Keypad Return A, 0 = Released, 1 = Pressed
;-----------------------------------------------------------------------------
read_keys:
	mov a, [n+KEY_PAD]
	push b
	mov b, [n+KEY_PAD]
	xor a, b
	mov a, b
	pop b
	jnz read_keys
	not a
	ret		
	
;-----------------------------------------------------------------------------
; suspend or not
;-----------------------------------------------------------------------------
do_i_suspend:
	test	[nn+BUTTONS], BUTTON_POWER
	jnz		_dont_suspend2
	int		IntSuspend
_dont_suspend2:
	ret

;---------------------------
; check for health being 0
;---------------------------
is_health_0:
	mov		a, [health10]
	cmp 	a, 96
	jnz		go_back_to_game
	
	mov a,0
	mov [screennumber],a
		
	;jmp main
	
go_back_to_game:
	ret


;-----------------------------------------------------------------------------	
; health meter
;-----------------------------------------------------------------------------	
show_health2:
		mov x1, TILEMAP+72
		mov a, [health10]	
		mov [x1], a

		mov x1, TILEMAP+84
		mov a, [health]
		mov [x1], a	

	mov b, 0
	mov a, 1
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]

			mov a,0
		mov [buttonpress],a


		mov hl, play_sfx_1_level_2|0x8000
		mov u, play_sfx_1_level_2>>15
		jmp hl		

	
lose_health_level_2:


		mov		a, [buttonpress]
		add		a, 1
		mov 	[buttonpress],a
			
		mov		a, [buttonpress] 
		cmp		a, 255
		jz		lose_health3_level_2
			
			
	mov b, 0
	mov a, 0
	shl a
	shl a
	mov hl, sfx_list+2
	add hl, ba
	mov b, [hl]
	dec hl
	dec hl
	mov hl, [hl]
	jmp show_health2			
	
lose_health3_level_2:
		mov a,0
		mov [buttonpress],a
	
		mov		a, [health]
		sub		a, 1
		mov		[health], a		
	
		mov		a, [health]
		cmp		a, 97
		jl		health_ten_2

		jmp show_health2

health_ten_2:
		mov		a, [health]
		add		a, 10
		mov		[health], a	

		mov		a, [health10]
		sub		a, 1
		mov		[health10], a		
		
		jmp show_health2		
		
	
	
;-----------------------------------------------------------------------------
; suspend or not
;-----------------------------------------------------------------------------
do_i_suspend2:
	test	[nn+BUTTONS], BUTTON_POWER
	jnz		_dont_suspend212
	int		IntSuspend
_dont_suspend212:
	ret	
	

move_frank_222:
		mov		a, [ticker]
		add		a, 1
		mov		[ticker], a
	
		mov		a, [ticker] 
		cmp		a, 255
		jl		move_frank___2224234123424124level2

		ret

move_frank___2224234123424124level2:
		mov		a, [ticker2]
		add		a, 1
		mov		[ticker2], a
	
		mov		a, [ticker2] 
		cmp		a, 77
		jl		move_frank22a
		
		ret
		
move_frank22a:
		mov a,0
		mov [ticker2],a	
	
		mov		a, [ticker3]
		add		a, 1
		mov		[ticker3], a

		mov		a, [ticker3] 
		cmp		a, 252
		jz		move_frank_in_game2

		ret	
		
move_frank_in_game2:
		call flap_wings_level_2

		mov a,0
		mov [ticker3],a	

		call read_keys
		test a, KEY_RIGHT
		jnz frank_right12
		
		call read_keys
		test a, KEY_LEFT
		jnz frank_left12

frank_y_movement2:
		call read_keys
		test a, KEY_UP
		jnz frank_up2
		
		call read_keys
		test a, KEY_DOWN
		jnz frank_down12
		
		ret
	
move_frank32:
		call flap_wings_level_2

		mov a,0
		mov [ticker3],a	
	
		mov		a, [frankdir] 
		cmp		a, 5
		jz		frank_right2	
	
		mov		a, [OAM+0] 
		cmp		a, 31
		jz		frank_down2	
	
		mov		a, [OAM+1] 
		cmp		a, 29
		jz		frank_left2
	
		mov		a, [OAM+0] 
		cmp		a, 80
		jz		frank_up2

frank_right2:
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a
	
		mov		a, [frankdir] 
		cmp		a, 5
		jz		frank_down_start2	
	
		ret
	
frank_right12:
		mov		a, [OAM+0] 
		cmp		a, 96
		jg		next_screen_2
		
		mov		a, [OAM+0]
		add		a, 1
		mov		[OAM+0], a
	
		jmp frank_y_movement2
	
next_screen_2:
		mov		a, [screenlock] 
		cmp		a, 0
		jg		nomove2	

		mov		a, [screennumber]
		add		a, 1
		mov		[screennumber], a	

		mov a,24
		mov [OAM+0],a	

		jmp level_2_stuff
	
frank_up2:
		mov		a, [OAM+1] 
		cmp		a, 17
		jz		nomove2

		mov		a, [OAM+1]
		sub		a, 1
		mov		[OAM+1], a
	
nomove2:
		ret
		
frank_left2:
		mov		a, [OAM+0] 
		cmp		a, 5
		jz		frank_right2	

frank_left12:
		mov		a, [OAM+0] 
		cmp		a, 24
		jz		nomove2

		mov		a, [OAM+0]
		sub		a, 1
		mov		[OAM+0], a
	
		jmp frank_y_movement2
		
frank_down_start2:
		mov		a, [wingsflap] 
		cmp		a, 2
		jl		frank_down2
		
		ret
		
frank_down2:
		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a

		ret
		
frank_down12:
		mov		a, [OAM+1] 
		cmp		a, 72
		jz		nomove2

		mov		a, [OAM+1]
		add		a, 1
		mov		[OAM+1], a
		ret
	
;-----------------------------------------------------------------------------
; Flap Wings
;-----------------------------------------------------------------------------	
flap_wings_level_2:
		call do_i_suspend2

		mov		a, [wingsflap]
		add		a, 1
		mov		[wingsflap], a

		mov		a, [wingsflap] 
		cmp		a, 2
		jz		wings_side_level2

		mov		a, [wingsflap] 
		cmp		a, 3
		jz		wings_down_level2

		mov		a, [wingsflap] 
		cmp		a, 4
		jz		wings_side_level2

		mov		a, [wingsflap] 
		cmp		a, 5
		jz		reset_wings_level_2
		
		ret		

wings_side_level2:
		mov a,0
		mov [OAM+2],a
		
		ret		

wings_down_level2:
		mov a,3
		mov [OAM+2],a
		
		ret		

reset_wings_level_2:
		mov a,1
		mov [wingsflap],a
		
		mov a,1
		mov [OAM+2],a
		
		ret
		